<?php

if (!empty($version_old) && version_compare((string)$version_old, '7.0.2.6', '<')) {
    $context = sfContext::getInstance();
    $config_big = stConfig::getInstance($context, 'appWishesResponsiveConfigBackend');

    $serialized_data = $config_big->get('wishes_responsive_images');

    if (!is_string($serialized_data) || trim($serialized_data) === '') {
        $images_array = [];
    } else {
        $images_array = @unserialize($serialized_data);
        if ($images_array === false || !is_array($images_array)) {
            $images_array = [];
        }
    }

    $new_images = [
        ['name' => 'responsive16.png', 'active' => '0'],
        ['name' => 'responsive17.png', 'active' => '0'],
        ['name' => 'responsive18.png', 'active' => '0'],
        ['name' => 'responsive19.png', 'active' => '0'],
    ];

    $images_array = array_merge($images_array, $new_images);

    $config_big->set('wishes_responsive_images', serialize($images_array));
    $config_big->save(true);
    $config_big->load();
}
