<?php
/** 
 * SOTESHOP/appEasterPlugin
 * 
 * 
 * @package     appeasterPlugin
 * @author      Bartosz Alejski <whiteface@whiteface.pl>
 */
class appEasterBackendActions extends stAdminGeneratorActions{

public function executeResponsiveConfig(){
        $this->forward_parameters = $this->getUser()->getAttributeHolder()->getAll('sf_admin/appEasterResponsiveConfigBackend/site_forward_parameters');

        $this->config = stConfig::getInstance($this->getContext(), 'appEasterResponsiveConfigBackend');

        $this->config->setCulture($this->getRequestParameter('culture', stLanguage::getOptLanguage()));
        
        $i18n = $this->getContext()->getI18N();
        $breadcrumbs = $this->getBreadcrumbs();
        $breadcrumbs->add($i18n->__('Wielkanoc'), '@appEasterPlugin' );
        $breadcrumbs->add($i18n->__('Konfiguracja'));

        $video_array = unserialize($this->config->get('easter_responsive_video'));
        
        $images_array = unserialize($this->config->get('easter_responsive_images'));

        $number_of_elements = count($images_array);

        $number_of_elements_video = count($video_array);


        if ($this->getRequest()->getMethod() == sfRequest::POST){

            $this->config->set('easter_responsive_on', $this->getRequestParameter('easter[easter_responsive_on]'));
            $this->config->set('easter_responsive_description', $this->getRequestParameter('easter[easter_responsive_description]'), true);
            $this->config->set('easter_responsive_link_on', $this->getRequestParameter('easter[easter_responsive_link_on]'));
            
            // ustawienie aktywnego zdjęcia
            if ($this->getRequestParameter('easter[image_radio]') || $this->getRequestParameter('easter[video_radio]')){

                // zerowanie tabel
                   for ($i = 1; $i <= $number_of_elements; $i++){
                      $images_array[$i]['active'] = 0;
                   }
                   for ($i = 0; $i <= $number_of_elements_video-1; $i++){
                      $video_array[$i]['active'] = 0;
                   }


               if ($this->getRequestParameter('easter[image_radio]')){

                   foreach ($images_array as $key => $image){
                      
                      if($image['name'] == $this->getRequestParameter('easter[image_radio]')){
                        $new_active = $key;
                      }
                   }
                   $images_array[$new_active]['active'] = 1;

                   $fileName = $this->getRequestParameter('easter[image_radio]');

               }elseif($this->getRequestParameter('easter[video_radio]')){

                   foreach ($video_array as  $key => $video){

                      if($video['name'] == $this->getRequestParameter('easter[video_radio]')){
                         $new_active = $key;
                      }

                   }
                   $video_array[$new_active]['active'] = 1;
                   
                   $fileName = $this->getRequestParameter('easter[video_radio]');

               }

            }

            // załadowanie nowego zdjęcia
            if ($this->getRequest()->getFileSize('easter[image]')){

               $fileName = $this->getRequest()->getFileName('easter[image]');

               $ext = $this->getRequest()->getFileExtension('easter[image]');

               if($ext=='.jpg' ||  $ext=='.gif' || $ext=='.png' || $ext=='.jpeg'){

                  $this->getRequest()->moveFile('easter[image]', sfConfig::get('sf_upload_dir') . '/easter_picture/' . $fileName);

                  for ($i = 1; $i <= $number_of_elements; $i++){
                     $images_array[$i]['active'] = 0;
                  }

                  for ($i = 0; $i <= $number_of_elements_video-1; $i++){
                     $video_array[$i]['active'] = 0;
                   }

                  $images_array[$number_of_elements+1]['name'] = $fileName;
                  $images_array[$number_of_elements+1]['active'] = 1;

               }elseif($ext == '.bin'){

                    $this->getRequest()->moveFile('easter[image]', sfConfig::get('sf_upload_dir') . '/easter_picture/' . $fileName);

                    for ($i = 1; $i <= $number_of_elements; $i++){
                         $images_array[$i]['active'] = 0;
                    }

                    for ($i = 0; $i <= $number_of_elements_video-1; $i++){
                         $video_array[$i]['active'] = 0;
                    }

                      $video_array[$number_of_elements_video]['name'] = $fileName;
                      $video_array[$number_of_elements_video]['active'] = 1;
               }

            }

            $this->config->set('easter_responsive_images', serialize($images_array));

            $this->config->set('easter_responsive_video', serialize($video_array));

            $this->config->set('easter_responsive_active_image', $fileName);

            $this->config->save();
            
            stFastCacheManager::clearCache();
            
            $this->setFlash('notice', 'Twoje zmiany zostały zapisane');
            
            $this->redirect('appEasterBackend/responsiveConfig?culture='.$this->getRequestParameter('culture', stLanguage::getOptLanguage()));
        }
        
        $this->images_array = $images_array;

        $this->video_array = $video_array;
   }

   


   public function executeDelete(){

       $fileName =  $this->getRequestParameter('name');

       $this->config = stConfig::getInstance($this->getContext(), 'appEasterResponsiveConfigBackend');
        
        $images_array = unserialize($this->config->get('easter_responsive_images'));

       $this->config->setCulture($this->getRequestParameter('culture', stLanguage::getOptLanguage()));

       $i = 1;
       $set_default = 0;
       foreach ($images_array as $key=>$image){
           
           if($image['name'] == $fileName){
               $new_active = $key;

               if($image['active']==1)
               {
                  $set_default = 1;
               }
           }
           $i++;
       }

       unset($images_array[$new_active]);

       if($set_default==1){
            $images_array[3]['active'] = 1;
       }
       

        $this->config->set('easter_responsive_images', serialize($images_array));
           
        if($set_default==1){
               $this->config->set('easter_responsive_active_image', 'responsive16.jpg');
        }
    
       $this->config->save();
       stFastCacheManager::clearCache();

       $this->redirect('appEasterBackend/responsiveConfig?culture='.$this->getRequestParameter('culture', stLanguage::getOptLanguage()));
   }

   public function executeDeleteVideo(){

    $fileName =  $this->getRequestParameter('name');

    $this->config = stConfig::getInstance($this->getContext(), 'appEasterResponsiveConfigBackend');
    
    $video_array = unserialize($this->config->get('easter_responsive_video'));

    $this->config->setCulture($this->getRequestParameter('culture', stLanguage::getOptLanguage()));

    $i = 0;
    $set_default = 0;
    foreach ($video_array as $key=>$video){
       
        if($video['name'] == $fileName){
           
            $new_active = $key;

            if($video['active']==1){
            $set_default = 1;
            }
       }
       $i++;
    }

    unset($video_array[$new_active]);

    if($set_default==1){
        $video_array[1]['active'] = 1;
    }

    $this->config->set('easter_responsive_video', serialize($video_array));
           
    if($set_default==1){
        $this->config->set('easter_responsive_active_image', 'easter-video1.mp4');
    }

    $this->config->save();
    
    stFastCacheManager::clearCache();
    
    $this->redirect('appEasterBackend/responsiveConfig?culture='.$this->getRequestParameter('culture', stLanguage::getOptLanguage()));
   
   }
   
}